; * detects an fsk modulated data transmission and samples it 2* 30 ms
; * note that the first 3 bit of the barker sync word get lost
; * this function will stop all system activity and all display
; * this function returns if data was detected or if LMB is pressed
; * use only 68000 with chip only for correct timing (54535 sampes/s)

;*****************************************************************************


XDEF	_SCAN

_SCAN:
		move.l	$4,a6
		jsr	-$78(a6)

		move.w	#%0000001000000000,$dff096

		bsr	scan

		move.w	#%1000001000000000,$dff096

		move.l	$4,a6
		jsr	-$7e(a6)
		move.l	return,d0
		rts


;*****************************************************************************
									
scan:
		or.b	#%00000110,$bfd200	;output sapler enable register
		and.b	#%11111001,$bfd000	;disable both samplers
		;or.b	#%00000010,$bfd000	;left sampler
		or.b	#%00000100,$bfd000	;right sampler (audiomaster)
		move.l	#sample,a0
		move.b	#10,d4			;noise treshold
		move.w	#$fff,d0
		moveq	#0,d1			;erase sample counter
		moveq	#1,d6			;loop counter value (1)
		moveq	#1,d7
;	bra	test
		;read until data found or mouse click

noise:		move.w	#20,d2

findloop:	btst	#6,$bfe001
		beq	scanint

		add.l	d7,d1			;count samples
		move.b	d0,d3
		move.b	$bfe101,d0		;read unsigned value
		move.w	d0,$dff180		;show colors
		sub.b	d0,d3			;calc dist
		btst	#7,d3
		beq	nosign
		neg.b	d3
nosign:		cmp.b	d4,d3			;noise if greater than trashhold
		bcc	noise

		sub.w	d6,d2			;if timed out
		bne	findloop

		;read until mouse or samples d2 read
test:		moveq	#1,d7
		moveq	#1,d6			;constant counter 1 (0 for test)
		move.l	#sample,a0
		moveq	#0,d1			;erase sample counter
		move.l	#4000,d2		;number of samples to scan (more than 2 slots)
		move.b	#30,d4			;noise treshold
		move.b	#%10000000,d5		;constant value for sign change

scanloop:	btst	#6,$bfe001
		beq	scanint
		move.b	$bfe101,d0		;read unsigned value
		eor.b	d5,d0			;change sign
		move.b	d0,(a0)			;write value
		move.w	d0,$dff180		;show colors
		add.l	d6,a0
		add.l	d7,d1
		sub.l	d6,d2
		bne	scanloop

		move.l	#sample,return		;vantab with resulting data
		rts

scanint:
;	move.l d1,return
		move.l	#0,return		;false (break by mouse)
		rts

;*****************************************************************************

return:		dc.l	0			;return value

sample:		blk.b 4000			;sample data for fsk data

;*****************************************************************************
